local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.Spec = s.TalentMastery()
	x.TimeToDie = s.TimeToDie("target") or 10
	x.InCombat = s.InCombat()
	x.Rage = s.Power("player", SPELL_POWER_RAGE )
	x.MaxRage = s.MaxPower("player", SPELL_POWER_RAGE)
	x.AoE = a.AoE()
	x.GCD = s.GlobalCooldown()
	
	a.Flash("pummel", "disrupting_shout")
	a.Flash("spell_reflection")
	a.Flash("charge")
	if x.Spec == 1 then
		-- Arms
		x.DebuffColossusSmashRemains = s.MyDebuffDuration(86346--[[Colossus Smash]], "target")
		x.CooldownColossusSmashRemains = s.SpellCooldown(86346--[[Colossus Smash]])
		x.BuffRecklessnessRemains = s.BuffDuration(1719--[[Recklessness]], "player")
		x.CooldownRecklessnessRemains = s.SpellCooldown(1719--[[Recklessness]])
		x.TargetPCT = s.HealthPercent("target")
		x.EnrageRemains = s.BuffDuration(12880--[[Enrage]], "player")
		a.Flash("stance,choose=battle")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=winters_bite",
			           "commanding_shout,if=precombat",
			           "battle_shout,if=precombat",
			           "mogu_power_potion")
		end
		a.Flash("auto_attack",
				"mogu_power_potion,if=(target.health.pct<20&buff.recklessness.up)|buff.bloodlust.react|target.time_to_die<=25",
				"blood_fury,if=buff.bloodbath.up|(!talent.bloodbath.enabled&debuff.colossus_smash.up)",
				"recklessness,if=!talent.bloodbath.enabled&((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20))|buff.bloodbath.up&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20)|target.time_to_die<=12",
				"bloodbath,if=enabled&(debuff.colossus_smash.up|cooldown.colossus_smash.remains<4)",
				"avatar,if=enabled&(buff.recklessness.up|target.time_to_die<=25)",
				"skull_banner,if=buff.skull_banner.down&(((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&target.time_to_die>192&buff.cooldown_reduction.up)|buff.recklessness.up)",
				"synapse_springs,if=debuff.colossus_smash.up",
				"berserker_rage,if=buff.enrage.remains<0.5",
				"heroic_leap,if=debuff.colossus_smash.up",
				"heroic_strike,if=rage>115|(debuff.colossus_smash.up&rage>60&set_bonus.tier16_2pc_melee)",
				"mortal_strike,if=dot.deep_wounds.remains<1.0|buff.enrage.down",
				"colossus_smash,if=debuff.colossus_smash.remains<1.0",
				"mortal_strike",
				"storm_bolt,if=enabled&debuff.colossus_smash.up",
				"dragon_roar,if=enabled&!debuff.colossus_smash.up",
				"execute,if=buff.sudden_execute.down|buff.taste_for_blood.down|rage>90|target.time_to_die<12",
				"overpower,if=target.health.pct>=20&rage<100|buff.sudden_execute.up",
				"slam,if=target.health.pct>=20",
				"battle_shout",
				"heroic_throw")
	elseif x.Spec == 2 then
		-- Fury
		x.DebuffColossusSmashRemains = s.MyDebuffDuration(86346--[[Colossus Smash]], "target")
		x.CooldownColossusSmashRemains = s.SpellCooldown(86346--[[Colossus Smash]])
		x.BuffRecklessnessRemains = s.BuffDuration(1719--[[Recklessness]], "player")
		x.CooldownRecklessnessRemains = s.SpellCooldown(1719--[[Recklessness]])
		x.TargetPCT = s.HealthPercent("target")
		x.EnrageRemains = s.BuffDuration(12880--[[Enrage]], "player")
		x.CooldownBloodthirstRemains = s.SpellCooldown(23881--[[Bloodthirst]])
		a.Flash("stance,choose=battle")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=winters_bite",
			           "commanding_shout,if=precombat",
			           "battle_shout,if=precombat",
			           "mogu_power_potion")
		end
		a.Flash("auto_attack",
				"mogu_power_potion,if=(target.health.pct<20&buff.recklessness.up)|target.time_to_die<=25",
				"blood_fury,if=buff.bloodbath.up|(!talent.bloodbath.enabled&debuff.colossus_smash.up)",
				"recklessness,if=!talent.bloodbath.enabled&((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20))|buff.bloodbath.up&(target.time_to_die>(192*buff.cooldown_reduction.value)|target.health.pct<20)|target.time_to_die<=12",
				"avatar,if=enabled&(buff.recklessness.up|target.time_to_die<=25)",
				"skull_banner,if=buff.skull_banner.down&(((cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5)&target.time_to_die>192&buff.cooldown_reduction.up)|buff.recklessness.up)",
				"synapse_springs,if=!talent.bloodbath.enabled&debuff.colossus_smash.up|buff.bloodbath.up",
				"berserker_rage,if=buff.enrage.remains<1&cooldown.bloodthirst.remains>1",
				"bloodbath,if=enabled&(cooldown.colossus_smash.remains<2|debuff.colossus_smash.remains>=5|target.time_to_die<=20)",
				"heroic_strike,if=((debuff.colossus_smash.up&rage>=40)&target.health.pct>=20)|rage>=100&buff.enrage.up",
				"heroic_leap,if=debuff.colossus_smash.up",
				"storm_bolt,if=enabled&buff.cooldown_reduction.up&debuff.colossus_smash.up",
				"raging_blow,if=buff.raging_blow.stack=2&debuff.colossus_smash.up&target.health.pct>=20",
				"storm_bolt,if=enabled&buff.cooldown_reduction.down&debuff.colossus_smash.up",
				"bloodthirst,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)",
				"wild_strike,if=buff.bloodsurge.react&target.health.pct>=20&cooldown.bloodthirst.remains<=1",
				"wait,sec=cooldown.bloodthirst.remains,if=!(target.health.pct<20&debuff.colossus_smash.up&rage>=30&buff.enrage.up)&cooldown.bloodthirst.remains<=1&cooldown.bloodthirst.remains",
				"dragon_roar,if=enabled&(!debuff.colossus_smash.up&(buff.bloodbath.up|!talent.bloodbath.enabled))",
				"colossus_smash",
				"storm_bolt,if=enabled&buff.cooldown_reduction.down",
				"execute,if=debuff.colossus_smash.up|rage>70|target.time_to_die<12",
				"raging_blow,if=target.health.pct<20|buff.raging_blow.stack=2|(debuff.colossus_smash.up|(cooldown.bloodthirst.remains>=1&buff.raging_blow.remains<=3))",
				"wild_strike,if=buff.bloodsurge.up",
				"bladestorm,if=enabled&cooldown.bloodthirst.remains>2",
				"raging_blow,if=cooldown.colossus_smash.remains>=3",
				"shockwave,if=enabled",
				"heroic_throw,if=debuff.colossus_smash.down&rage<60",
				"battle_shout,if=rage<70&!debuff.colossus_smash.up",
				"wild_strike,if=debuff.colossus_smash.up&target.health.pct>=20",
				"battle_shout,if=rage<70",
				"shattering_throw,if=cooldown.colossus_smash.remains>5",
				"wild_strike,if=cooldown.colossus_smash.remains>=2&rage>=70&target.health.pct>=20",
				"impending_victory,if=enabled&target.health.pct>=20&cooldown.colossus_smash.remains>=2")
	elseif x.Spec == 3 then
		-- Protection
		x.whb = a.wouldHaveBlocked()
		x.wha = a.wouldHaveAbsorbed()
		x.IncomingDamage2500ms = a.incomingDamage(2.5)
		x.Vengeance = a.getVengeance()
		a.Flash("stance,choose=defensive")
		a.Flash("taunt")
		if not x.InCombat and x.EnemyDetected then
			a.FlashAll("flask,type=earth",
			           "commanding_shout,if=precombat",
			           "battle_shout,if=precombat",
			           "mountains_potion")
		end
		a.Flash("auto_attack",
				"mountains_potion,if=incoming_damage_2500ms>health.max*0.6&(buff.shield_wall.down&buff.last_stand.down)",
--				"use_item,name=curse_of_hubris",
				"heroic_strike,if=buff.ultimatum.up|buff.glyph_incite.up",
				"berserker_rage,if=buff.enrage.down&rage<=rage.max-10",
				"shield_block",
				"shield_barrier",
				"shield_wall,if=incoming_damage_2500ms>health.max*0.6",
				"last_stand,if=incoming_damage_2500ms>health.max*0.6&buff.shield_wall.down",
				"avatar,if=talent.avatar.enabled&buff.vengeance.value>health.max*0.20",
				"bloodbath,if=talent.bloodbath.enabled&buff.vengeance.value>health.max*0.20",
				"blood_fury,if=buff.vengeance.value>health.max*0.20",
				"dragon_roar,if=talent.dragon_roar.enabled&buff.vengeance.value>health.max*0.20",
				"shattering_throw,if=buff.vengeance.value>health.max*0.20",
				"skull_banner,if=buff.skull_banner.down&buff.vengeance.value>health.max*0.20",
				"recklessness,if=buff.vengeance.value>health.max*0.20",
				"storm_bolt,if=talent.storm_bolt.enabled&buff.vengeance.value>health.max*0.20",
				"shockwave,if=talent.shockwave.enabled&buff.vengeance.value>health.max*0.20",
				"bladestorm,if=talent.bladestorm.enabled&buff.vengeance.value>health.max*0.20",
				"shield_slam",
				"revenge",
				"battle_shout,if=rage<=rage.max-20",
				"thunder_clap,if=glyph.resonating_power.enabled|target.debuff.weakened_blows.down",
				"demoralizing_shout",
				"impending_victory,if=talent.impending_victory.enabled",
				"victory_rush,if=!talent.impending_victory.enabled",
				"devastate")
	end
	
end)


